diff -Nru linux-2.6.9.orig/drivers/scsi/sg.c linux-2.6.9/drivers/scsi/sg.c
--- linux-2.6.9.orig/drivers/scsi/sg.c	2005-10-13 17:35:35.000000000 +0200
+++ linux-2.6.9/drivers/scsi/sg.c	2005-10-13 18:29:46.161808170 +0200
@@ -533,6 +533,14 @@
 		if ((opcode >= 0xc0) && old_hdr.twelve_byte)
 			cmd_size = 12;
 	}
+
+	/* Support IBM Load Display command on IBM3590.
+	 * Command opcode is 0xC0 and CDB len is 6 instead of 10.
+	 * Originally by Fabien Collin. */
+	if ((opcode == 0xc0) && (old_hdr.twelve_byte == 0)) {
+		cmd_size = 6;
+	}
+
 	SCSI_LOG_TIMEOUT(4, printk(
 		"sg_write:   scsi opcode=0x%02x, cmd_size=%d\n", (int) opcode, cmd_size));
 /* Determine buffer size.  */
